'==========================================================
'	ARTRAY Camera / Capture Module Software Developer Kit
'
'						Version 1.20		2003.9.4
'						Version 1.21		2003.9.18
'						Version 1.22		2003.10.10
'						Version 1.23		2004.1.21
'						Version 1.235		2004.3.19
'						Version 1.24		2004.7.9
'						Version 1.245		2004.8.17
'						Version 1.25		2004.9.1
'						Version 1.26		2004.10.28
'						Version 1.27		2005.3.8
'						Version 1.275		2005.5.23
'						Version 1.276		2005.6.27
'						Version 1.277		2005.12.22
'						Version 1.280		2007.4.4
'						Version 1.300		2009.4.24
'
'									(C) 2002-2009 Artray
'==========================================================

Namespace ArtCamSdk

    Public Enum DLL_MESSAGE
        WM_GRAPHNOTIFY = &H8001  ' {o[Wł͎gp܂
        WM_GRAPHPAINT            ' fXVꂽɃAvP[Vɑ܂
        WM_ERROR                 ' G[ɃAvP[Vɑ܂
    End Enum

    Public Enum ARTCAM_CAMERATYPE
        ARTCAM_CAMERATYPE_DS = 1        ' DirectShow Camera
        ARTCAM_CAMERATYPE_DISABLE1      ' 
        ARTCAM_CAMERATYPE_USTC          ' ARTUST-0209C
        ARTCAM_CAMERATYPE_CNV           ' ARTCNV
        ARTCAM_CAMERATYPE_DISABLE2      ' 
        ARTCAM_CAMERATYPE_130MI         ' ARTCAM-130MI
        ARTCAM_CAMERATYPE_DISABLE3      ' 
        ARTCAM_CAMERATYPE_200MI         ' ARTCAM-200MI
        ARTCAM_CAMERATYPE_300MI         ' ARTCAM-300MI
        ARTCAM_CAMERATYPE_150P          ' ARTCAM-150P
        ARTCAM_CAMERATYPE_320P          ' ARTCAM-320P
        ARTCAM_CAMERATYPE_DISABLE4      ' 
        ARTCAM_CAMERATYPE_200SH         ' ARTCAM-200SH
        ARTCAM_CAMERATYPE_098           ' ARTCAM-098
        ARTCAM_CAMERATYPE_036MI         ' ARTCAM-036MI
        ARTCAM_CAMERATYPE_500P          ' ARTCAM-500P
        ARTCAM_CAMERATYPE_150P2         ' ARTCAM-150P2
        ARTCAM_CAMERATYPE_036MIST       ' ARTCAM-036MIST
        ARTCAM_CAMERATYPE_500MI         ' ARTCAM-500MI
        ARTCAM_CAMERATYPE_DISABLE5      ' 
        ARTCAM_CAMERATYPE_DISABLE6      ' 
        ARTCAM_CAMERATYPE_150P3         ' ARTCAM-150PV
        ARTCAM_CAMERATYPE_130MI_MOUT    ' ARTCAM-130MI MOUT
        ARTCAM_CAMERATYPE_150P3_MOUT    ' ARTCAM-150PV MOUT
        ARTCAM_CAMERATYPE_267KY         ' ARTCAM-267KY
        ARTCAM_CAMERATYPE_274KY         ' ARTCAM-274KY
        ARTCAM_CAMERATYPE_625KY         ' ARTCAM-274KY
        ARTCAM_CAMERATYPE_V135MI        ' ARTCAM-V135MI
        ARTCAM_CAMERATYPE_445KY         ' ARTCAM-445KY
        ARTCAM_CAMERATYPE_098II         ' ARTCAM-098II
        ARTCAM_CAMERATYPE_MV413         ' ARTCAM-MV413USB
        ARTCAM_CAMERATYPE_OV210         ' ARTCAM-OV210
        ARTCAM_CAMERATYPE_850SH         ' ARTCAM-850SH
        ARTCAM_CAMERATYPE_1251SH        ' ARTCAM-1252SH
        ARTCAM_CAMERATYPE_D131          ' ARTCAM-D131
        ARTCAM_CAMERATYPE_900MI         ' ARTCAM-900MI
        ARTCAM_CAMERATYPE_1000MI        ' ARTCAM-1000MI
        ARTCAM_CAMERATYPE_500P2         ' ARTCAM-500P2

        ARTCAM_CAMERATYPE_SATA = 201    ' SATA Camera = 201
    End Enum
    '
    'SATA J^Cv
    Public Enum ARTCAM_CAMERATYPE_SATA
        ARTCAM_CAMERATYPE_SATA_LVDS = 0
        ARTCAM_CAMERATYPE_SATA_300MI
        ARTCAM_CAMERATYPE_SATA_500MI
        ARTCAM_CAMERATYPE_SATA_MV413
        ARTCAM_CAMERATYPE_SATA_800MI
        ARTCAM_CAMERATYPE_SATA_036MI
        ARTCAM_CAMERATYPE_SATA_150P
        ARTCAM_CAMERATYPE_SATA_274KY
        ARTCAM_CAMERATYPE_SATA_625KY
        ARTCAM_CAMERATYPE_SATA_130MI
        ARTCAM_CAMERATYPE_SATA_200MI
    End Enum

    Public Enum VGA_MODE
        VGA_MODE_800_600 = 0    ' 800   x    600
        VGA_MODE_1024_768       '1024   x    768
        VGA_MODE_1280_1024      '1280   x   1024
        VGA_MODE_NUM
    End Enum

    Public Enum VGA_SENSOR_CLOCK
        VGA_SENSOR_CLOCK_16 = 0
        VGA_SENSOR_CLOCK_24
        VGA_SENSOR_CLOCK_48
        VGA_SENSOR_CLOCK_NUM
    End Enum


    ' G[R[h
    Public Enum ARTCAMSDK_ERROR
        ARTCAMSDK_NOERROR = 0       ' 
        ARTCAMSDK_NOT_INITIALIZE    ' Ă܂
        ARTCAMSDK_DISABLEDDEVICE    ' ps\ȃfoCXɃANZX悤Ƃ܂
        ARTCAMSDK_CREATETHREAD      ' 摜荞ݗpXbh쐬Ɏs
        ARTCAMSDK_CREATEWINDOW      ' EBhE쐬Ɏs
        ARTCAMSDK_OUTOFMEMORY       ' C[W]ɏ\ȃmۂĂȂ@́@̊mۂɎs
        ARTCAMSDK_CAMERASET         ' JifoCXj̐ݒŃG[
        ARTCAMSDK_CAMERASIZE        ' JifoCXj̃TCYݒŃG[
        ARTCAMSDK_CAPTURE           ' f荞݂Ŏs
        ARTCAMSDK_PARAM             ' ԈĂ܂
        ARTCAMSDK_DIRECTSHOW        ' DirectShow G[
        ARTCAMSDK_UNSUPPORTED       ' ̋@\̓T|[gĂ܂
        ARTCAMSDK_UNKNOWN           ' s̃G[
        ARTCAMSDK_CAPTURELOST       ' foCX
        ARTCAMSDK_FILENOTFOUND      ' wt@CȂ
        ARTCAMSDK_FPGASET           ' FPGA̐ݒŃG[
        ARTCAMSDK_TRANSIMAGEFAILED  ' 摜]Ɏs
    End Enum

    ' 摜tB^[̎
    Public Enum ARTCAM_FILTERTYPE
        ARTCAM_FILTERTYPE_RESERVE = 0       ' \񂳂Ă܂
        ARTCAM_FILTERTYPE_BRIGHTNESS        ' 邳
        ARTCAM_FILTERTYPE_CONTRAST          ' RgXg
        ARTCAM_FILTERTYPE_HUE               ' F
        ARTCAM_FILTERTYPE_SATURATION        ' ʓx
        ARTCAM_FILTERTYPE_SHARPNESS         ' N
        ARTCAM_FILTERTYPE_BAYER_GAIN_RGB    ' xC[ϊ̃J[QC
        ARTCAM_FILTERTYPE_BAYER_GAIN_R      ' xC[ϊ̃J[QCiԂ̂݁j
        ARTCAM_FILTERTYPE_BAYER_GAIN_G      ' xC[ϊ̃J[QCi΂̂݁j
        ARTCAM_FILTERTYPE_BAYER_GAIN_B      ' xC[ϊ̃J[QCi̂݁j
        ARTCAM_FILTERTYPE_BAYER_GAIN_AUTO   ' zCgoX
        ARTCAM_FILTERTYPE_GAMMA             ' K}
        ARTCAM_FILTERTYPE_BAYERMODE         ' xC[ϊ[h
        ARTCAM_FILTERTYPE_GLOBAL_GAIN       ' J̃O[oQC
        ARTCAM_FILTERTYPE_COLOR_GAIN_R      ' J̃J[QCiԁj
        ARTCAM_FILTERTYPE_COLOR_GAIN_G1     ' J̃J[QCi΂Pj
        ARTCAM_FILTERTYPE_COLOR_GAIN_G2     ' J̃J[QCi΂Qj
        ARTCAM_FILTERTYPE_COLOR_GAIN_B      ' J̃J[QCij
        ARTCAM_FILTERTYPE_EXPOSURETIME      ' IԁiVb^[Xs[hj
        ARTCAM_FILTERTYPE_GRAY_MODE         ' O[XP[@[h
        ARTCAM_FILTERTYPE_GRAY_GAIN_R       ' O[XP[@QCiԁj
        ARTCAM_FILTERTYPE_GRAY_GAIN_G1      ' O[XP[@QCi΂Pj
        ARTCAM_FILTERTYPE_GRAY_GAIN_G2      ' O[XP[@QCi΂Qj
        ARTCAM_FILTERTYPE_GRAY_GAIN_B       ' O[XP[@QCij
        ARTCAM_FILTERTYPE_GRAY_OFFSET_R     ' O[XP[@ItZbgiԁj
        ARTCAM_FILTERTYPE_GRAY_OFFSET_G1    ' O[XP[@ItZbgi΂Pj
        ARTCAM_FILTERTYPE_GRAY_OFFSET_G2    ' O[XP[@ItZbgi΂Qj
        ARTCAM_FILTERTYPE_GRAY_OFFSET_B     ' O[XP[@ItZbgij
    End Enum

    ' Ԉ][h
    Public Enum SUBSAMPLE
        SUBSAMPLE_1 = 0  ' tTCY
        SUBSAMPLE_2      ' P^Q
        SUBSAMPLE_4      ' P^S
        SUBSAMPLE_8      ' P^W
        BINNING_2 = 16
        BINNING_4 = 17

    End Enum

    ' I[gACX[h
    Public Enum AI_TYPE
        AI_NONE = 0        ' 
        AI_EXPOSURE        ' Io
        AI_GAIN            ' QC
        AI_BOTH            ' 
    End Enum

    ' O[XP[[h
    Public Enum GRAY_TYPE
        GRAY_NONE = 0       ' @xC[ẑ܂
        GRAY_BAYERCONVERT   ' xC[z GRAY GAIN  GRAY OFFSET ŉZ
        GRAY_GRAYSCALE      ' J[ϊAPx݂̂ɂ
    End Enum

    ' rfItH[}bg
    Public Enum VIDEOFORMAT
        VIDEOFORMAT_NTSC = 0    ' NTSC
        VIDEOFORMAT_PAL         ' PAL
        VIDEOFORMAT_PALM        ' PALM
        VIDEOFORMAT_SECAM       ' SECAM
    End Enum

    ' TvO[g
    Public Enum SAMPLING_RATE
        WIDE_HISPEED = 0    ' 
        WIDE_LOWSPEED       ' 
        NORMAL_HISPEED      ' 
        NORMAL_LOWSPEED     ' 
    End Enum

    ' 摜ۑ`
    Public Enum FILETYPE
        FILETYPE_BITMAP = 0
        FILETYPE_RAW
        FILETYPE_JPEG_HIGH
        FILETYPE_JPEG_NOMAL
        FILETYPE_JPEG_LOW
        FILETYPE_PNG
        FILETYPE_TIFF
    End Enum


    Public Class ArtCam

        Declare Function GetDllVersion Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetDllVersion" () As Integer
        Declare Function GetLastError Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetLastError" (ByVal hACam As Integer) As Integer

        Declare Function Initialize Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Initialize" (ByVal hWnd As IntPtr) As Integer
        Declare Function Release Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Release" (ByVal hACam As Integer) As Integer

        Declare Function Preview Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Preview" (ByVal hACam As Integer) As Integer
        Declare Function Record Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Record" (ByVal hACam As Integer, ByVal lpAviName As String, ByVal RecTime As Integer, ByVal fShow As Integer) As Integer
        Declare Function CallBackPreviewA Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_CallBackPreview" (ByVal hACam As Integer, ByVal hWnd As IntPtr, ByVal lpImage As Byte(), ByVal Size As Integer, ByVal TopDown As Integer) As Integer
        Declare Function CallBackPreviewP Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_CallBackPreview" (ByVal hACam As Integer, ByVal hWnd As IntPtr, ByVal lpImage As IntPtr, ByVal Size As Integer, ByVal TopDown As Integer) As Integer
        Declare Function SnapShotA Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SnapShot" (ByVal hACam As Integer, ByVal lpImage As Byte(), ByVal Size As Integer, ByVal TopDown As Integer) As Integer
        Declare Function SnapShotP Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SnapShot" (ByVal hACam As Integer, ByVal lpImage As IntPtr, ByVal Size As Integer, ByVal TopDown As Integer) As Integer
        Declare Function Close Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Close" (ByVal hACam As Integer) As Integer

        ' 1250
        Declare Function Capture Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Capture" (ByVal hACam As Integer) As Integer

        ' 1260
        Declare Function TriggerA Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Trigger" (ByVal hACam As Integer, ByVal hWnd As IntPtr, ByVal lpImage As Byte(), ByVal Size As Integer, ByVal TopDown As Integer) As Integer
        Declare Function TriggerP Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Trigger" (ByVal hACam As Integer, ByVal hWnd As IntPtr, ByVal lpImage As IntPtr, ByVal Size As Integer, ByVal TopDown As Integer) As Integer
        Declare Function SaveImage Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SaveImage" (ByVal hACam As Integer, ByVal lpSaveName As String, ByVal FileType As FILETYPE) As Integer

        Declare Function SetPreviewWindow Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetPreviewWindow" (ByVal hACam As Integer, ByVal hWnd As IntPtr, ByVal Left As Integer, ByVal Top As Integer, ByVal Right As Integer, ByVal Bottom As Integer) As Integer
        Declare Function SetCaptureWindow Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetCaptureWindow" (ByVal hACam As Integer, ByVal Width As Integer, ByVal Height As Integer, ByVal Frame As Integer) As Integer
        Declare Function SetCaptureWindowEx Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetCaptureWindowEx" (ByVal hACam As Integer, ByVal HTotal As Integer, ByVal HStart As Integer, ByVal HEffective As Integer, ByVal VTotal As Integer, ByVal VStart As Integer, ByVal VEffective As Integer) As Integer
        Declare Function GetCaptureWindowEx Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetCaptureWindowEx" (ByVal hACam As Integer, ByRef HTotal As Integer, ByRef HStart As Integer, ByRef HEffective As Integer, ByRef VTotal As Integer, ByRef VStart As Integer, ByRef VEffective As Integer) As Integer

        Declare Function SetColorMode Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetColorMode" (ByVal hACam As Integer, ByVal ColorMode As Integer) As Integer
        Declare Function GetColorMode Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetColorMode" (ByVal hACam As Integer) As Integer

        Declare Function SetCrossbar Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetCrossbar" (ByVal hACam As Integer, ByVal Output As Integer, ByVal Input As Integer) As Integer
        Declare Function SetDeviceNumber Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetDeviceNumber" (ByVal hACam As Integer, ByVal Number As Integer) As Integer
        Declare Function GetDeviceName Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetDeviceName" (ByVal hACam As Integer, ByVal index As Integer, ByVal szDeviceName As System.Text.StringBuilder, ByVal Size As Integer) As Integer

        Declare Function StartPreview Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_StartPreview" (ByVal hACam As Integer) As Integer
        Declare Function StopPreview Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_StopPreview" (ByVal hACam As Integer) As Integer
        Declare Function GetImageA Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetImage" (ByVal hACam As Integer, ByVal lpImage As Byte(), ByVal Size As Integer, ByVal TopDown As Integer) As Integer
        Declare Function GetImageP Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetImage" (ByVal hACam As Integer, ByVal lpImage As IntPtr, ByVal Size As Integer, ByVal TopDown As Integer) As Integer

        Declare Function Width Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Width" (ByVal hACam As Integer) As Integer
        Declare Function Height Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Height" (ByVal hACam As Integer) As Integer
        Declare Function Fps Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Fps" (ByVal hACam As Integer) As Integer

        Declare Function SetCameraDlg Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetCameraDlg" (ByVal hACam As Integer, ByVal hWnd As IntPtr) As Integer
        Declare Function SetImageDlg Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetImageDlg" (ByVal hACam As Integer, ByVal hWnd As IntPtr) As Integer
        Declare Function SetAnalogDlg Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetAnalogDlg" (ByVal hACam As Integer, ByVal hWnd As IntPtr) As Integer

        ' 1230
        Declare Function SetIOPort Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetIOPort" (ByVal hACam As Integer, ByVal byteData As Integer, ByVal longData As Integer, ByVal Reserve As Integer) As Integer
        Declare Function GetIOPort Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetIOPort" (ByVal hACam As Integer, ByRef byteData As Byte, ByRef longData As Integer, ByVal Reserve As Integer) As Integer

        Declare Function SetFilterValue Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetFilterValue" (ByVal hACam As Integer, ByVal FilterType As Integer, ByVal Value As Integer) As Integer
        Declare Function GetFilterValue Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetFilterValue" (ByVal hACam As Integer, ByVal FilterType As Integer, ByRef pError As Integer) As Integer

        Declare Function SetSubSample Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetSubSample" (ByVal hACam As Integer, ByVal SubSampleMode As Integer) As Integer
        Declare Function GetSubSample Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetSubSample" (ByVal hACam As Integer) As Integer

        Declare Function SetWaitTime Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetWaitTime" (ByVal hACam As Integer, ByVal WaitTime As Integer) As Integer
        Declare Function GetWaitTime Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetWaitTime" (ByVal hACam As Integer) As Integer

        ' 1240
        Declare Function SetMirrorV Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetMirrorV" (ByVal hACam As Integer, ByVal Flg As Integer) As Integer
        Declare Function GetMirrorV Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetMirrorV" (ByVal hACam As Integer) As Integer

        Declare Function SetMirrorH Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetMirrorH" (ByVal hACam As Integer, ByVal Flg As Integer) As Integer
        Declare Function GetMirrorH Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetMirrorH" (ByVal hACam As Integer) As Integer

        Declare Function SetBrightness Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetBrightness" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetBrightness Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetBrightness" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetContrast Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetContrast" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetContrast Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetContrast" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetHue Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetHue" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetHue Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetHue" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetSaturation Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetSaturation" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetSaturation Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetSaturation" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetSharpness Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetSharpness" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetSharpness Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetSharpness" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetBayerGainRGB Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetBayerGainRGB" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetBayerGainRGB Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetBayerGainRGB" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetBayerGainRed Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetBayerGainRed" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetBayerGainRed Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetBayerGainRed" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetBayerGainGreen Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetBayerGainGreen" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetBayerGainGreen Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetBayerGainGreen" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetBayerGainBlue Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetBayerGainBlue" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetBayerGainBlue Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetBayerGainBlue" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetBayerGainAuto Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetBayerGainAuto" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetBayerGainAuto Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetBayerGainAuto" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetGamma Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetGamma" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetGamma Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetGamma" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetBayerMode Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetBayerMode" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetBayerMode Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetBayerMode" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetGlobalGain Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetGlobalGain" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetGlobalGain Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetGlobalGain" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetColorGainRed Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetColorGainRed" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetColorGainRed Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetColorGainRed" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetColorGainGreen1 Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetColorGainGreen1" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetColorGainGreen1 Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetColorGainGreen1" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetColorGainGreen2 Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetColorGainGreen2" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetColorGainGreen2 Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetColorGainGreen2" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetColorGainBlue Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetColorGainBlue" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetColorGainBlue Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetColorGainBlue" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetExposureTime Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetExposureTime" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetExposureTime Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetExposureTime" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        ' 1260
        Declare Function SetHalfClock Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetHalfClock" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetHalfClock Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetHalfClock" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetAutoIris Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetAutoIris" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetAutoIris Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetAutoIris" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        ' 1275
        Declare Function SetSamplingRate Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetSamplingRate" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetSamplingRate Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetSamplingRate" (ByVal hACam As Integer, ByRef pError As Integer) As Integer
        Declare Function GetVideoFormat Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetVideoFormat" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        ' 1276
        Declare Function WriteSromID Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_WriteSromID" (ByVal hACam As Integer, ByVal Address As Integer, ByVal Value As Integer) As Integer
        Declare Function ReadSromID Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_ReadSromID" (ByVal hACam As Integer, ByVal Address As Integer, ByRef pError As Integer) As Integer

        ' 1280
        Declare Function GetStatus Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetStatus" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function WriteRegister Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_WriteRegister" (ByVal hACam As Integer, ByVal Address As Byte, ByVal Value As Integer) As Integer
        Declare Function ReadRegister Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_ReadRegister" (ByVal hACam As Integer, ByVal Address As Byte, ByRef pError As Integer) As Integer

        Declare Function SetGrayMode Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetGrayMode" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetGrayMode Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetGrayMode" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetGrayGainR Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetGrayGainR" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetGrayGainR Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetGrayGainR" (ByVal hACam As Integer, ByRef pError As Integer) As Integer
        Declare Function SetGrayGainG1 Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetGrayGainG1" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetGrayGainG1 Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetGrayGainG1" (ByVal hACam As Integer, ByRef pError As Integer) As Integer
        Declare Function SetGrayGainG2 Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetGrayGainG2" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetGrayGainG2 Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetGrayGainG2" (ByVal hACam As Integer, ByRef pError As Integer) As Integer
        Declare Function SetGrayGainB Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetGrayGainB" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetGrayGainB Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetGrayGainB" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetGrayOffsetR Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetGrayOffsetR" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetGrayOffsetR Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetGrayOffsetR" (ByVal hACam As Integer, ByRef pError As Integer) As Integer
        Declare Function SetGrayOffsetG1 Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetGrayOffsetG1" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetGrayOffsetG1 Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetGrayOffsetG1" (ByVal hACam As Integer, ByRef pError As Integer) As Integer
        Declare Function SetGrayOffsetG2 Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetGrayOffsetG2" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetGrayOffsetG2 Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetGrayOffsetG2" (ByVal hACam As Integer, ByRef pError As Integer) As Integer
        Declare Function SetGrayOffsetB Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetGrayOffsetB" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function GetGrayOffsetB Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetGrayOffsetB" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetCameraType Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetCameraType" (ByVal hACam As Integer, ByVal Flg As Integer) As Integer
        Declare Function GetCameraType Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetCameraType" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function Fpga_WriteRegister Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Fpga_WriteRegister" (ByVal hACam As Integer, ByVal Address As Byte, ByVal Value As Integer) As Integer
        Declare Function Fpga_ReadRegister Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Fpga_ReadRegister" (ByVal hACam As Integer, ByVal Address As Byte, ByRef pError As Integer) As Integer

        Declare Function Monitor_SetPreviewMode Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_SetPreviewMode" (ByVal hACam As Integer, ByVal Preview As Boolean) As Integer
        Declare Function Monitor_GetPreviewMode Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_GetPreviewMode" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function Monitor_SetPreviewSize Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_SetPreviewSize" (ByVal hACam As Integer, ByVal Width As Integer, ByVal Height As Integer) As Integer
        Declare Function Monitor_GetPreviewSize Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_GetPreviewSize" (ByVal hACam As Integer, ByRef Width As Integer, ByRef Height As Integer) As Integer

        Declare Function Monitor_SetColorMode Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_SetColorMode" (ByVal hACam As Integer, ByVal ColorMode As Boolean) As Integer
        Declare Function Monitor_GetColorMode Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_GetColorMode" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function Monitor_SetCameraClock Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_SetCameraClock" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function Monitor_GetCameraClock Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_GetCameraClock" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function Monitor_SetBayerGainAuto Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_SetBayerGainAuto" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function Monitor_GetBayerGainAuto Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_GetBayerGainAuto" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function Monitor_SetBayerGainLock Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_SetBayerGainLock" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function Monitor_GetBayerGainLock Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_GetBayerGainLock" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function Monitor_SetBayerGainRed Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_SetBayerGainRed" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function Monitor_GetBayerGainRed Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_GetBayerGainRed" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function Monitor_SetBayerGainGreen Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_SetBayerGainGreen" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function Monitor_GetBayerGainGreen Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_GetBayerGainGreen" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function Monitor_SetBayerGainBlue Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_SetBayerGainBlue" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function Monitor_GetBayerGainBlue Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_GetBayerGainBlue" (ByVal hACam As Integer, ByRef pError As Integer) As Integer



        ' 1282
        Declare Function SetSyncV Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetSyncV" (ByVal hACam As Integer, ByVal Flg As Integer) As Integer
        Declare Function GetSyncV Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetSyncV" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function SetSyncH Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_SetSyncH" (ByVal hACam As Integer, ByVal Flg As Integer) As Integer
        Declare Function GetSyncH Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetSyncH" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function WriteRegisterEx Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_WriteRegisterEx" (ByVal hACam As Integer, ByVal Address As Integer, ByVal Value As Integer) As Integer
        Declare Function ReadRegisterEx Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_ReadRegisterEx" (ByVal hACam As Integer, ByVal Address As Integer, ByRef pError As Integer) As Integer
        Declare Function Monitor_LoadFirmware Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_LoadFirmware" (ByVal hACam As Integer, ByVal szFileName As System.Text.StringBuilder)

        Declare Function Monitor_SaveCurrentSettings Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_SaveCurrentSettings" (ByVal hACam As Integer) As Integer
        Declare Function Monitor_InitRegisterSettings Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_InitRegisterSettings" (ByVal hACam As Integer, ByVal Flg As Integer) As Integer

        Declare Function Monitor_SetCrossCursorMode Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_SetCrossCursorMode" (ByVal hACam As Integer, ByVal CursorNum As Integer, ByVal Value As Integer) As Integer
        Declare Function Monitor_GetCrossCursorMode Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_GetCrossCursorMode" (ByVal hACam As Integer, ByVal CursorNum As Integer, ByRef pError As Integer) As Integer

        Declare Function Monitor_SetCrossCursorColorR Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_SetCrossCursorColorR" (ByVal hACam As Integer, ByVal CursorNum As Integer, ByVal Value As Integer) As Integer
        Declare Function Monitor_GetCrossCursorColorR Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_GetCrossCursorColorR" (ByVal hACam As Integer, ByVal CursorNum As Integer, ByRef pError As Integer) As Integer

        Declare Function Monitor_SetCrossCursorColorG Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_SetCrossCursorColorG" (ByVal hACam As Integer, ByVal CursorNum As Integer, ByVal Value As Integer) As Integer
        Declare Function Monitor_GetCrossCursorColorG Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_GetCrossCursorColorG" (ByVal hACam As Integer, ByVal CursorNum As Integer, ByRef pError As Integer) As Integer

        Declare Function Monitor_SetCrossCursorColorB Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_SetCrossCursorColorB" (ByVal hACam As Integer, ByVal CursorNum As Integer, ByVal Value As Integer) As Integer
        Declare Function Monitor_GetCrossCursorColorB Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_GetCrossCursorColorB" (ByVal hACam As Integer, ByVal CursorNum As Integer, ByRef pError As Integer) As Integer

        Declare Function Monitor_SetCrossCursorColorRGB Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_SetCrossCursorColorRGB" (ByVal hACam As Integer, ByVal CursorNum As Integer, ByVal Value As Integer) As Integer
        Declare Function Monitor_GetCrossCursorColorRGB Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_GetCrossCursorColorRGB" (ByVal hACam As Integer, ByVal CursorNum As Integer, ByRef pError As Integer) As Integer

        Declare Function Monitor_SetCrossCursorPos Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_SetCrossCursorPos" (ByVal hACam As Integer, ByVal CursorNum As Integer, ByVal ValueX As Integer, ByVal ValueY As Integer) As Integer
        Declare Function Monitor_GetCrossCursorPos Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_GetCrossCursorPos" (ByVal hACam As Integer, ByVal CursorNum As Integer, ByRef ValueX As Integer, ByRef ValueY As Integer) As Integer

        Declare Function Monitor_SetCrossCursorSize Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_SetCrossCursorSize" (ByVal hACam As Integer, ByVal CursorNum As Integer, ByVal ValueX As Integer, ByVal ValueY As Integer) As Integer
        Declare Function Monitor_GetCrossCursorSize Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_GetCrossCursorSize" (ByVal hACam As Integer, ByVal CursorNum As Integer, ByRef ValueX As Integer, ByRef ValueY As Integer) As Integer

        Declare Function Monitor_SetAutoIrisMode Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_SetAutoIrisMode" (ByVal hACam As Integer, ByVal Value As Integer) As Integer
        Declare Function Monitor_GetAutoIrisMode Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_GetAutoIrisMode" (ByVal hACam As Integer, ByRef pError As Integer) As Integer

        Declare Function Monitor_SetAutoIrisRange Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_SetAutoIrisRange" (ByVal hACam As Integer, ByVal Min As Integer, ByVal Max As Integer) As Integer
        Declare Function Monitor_GetAutoIrisRange Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_Monitor_GetAutoIrisRange" (ByVal hACam As Integer, ByRef Min As Integer, ByRef Max As Integer) As Integer


        ' 1300
        Declare Function GetRealExposureTime Lib "ArtCamSdk_130MI.dll" Alias "ArtCam_GetRealExposureTime" (ByVal hACam As Integer) As Integer

    End Class



    Public Class CArtCam

        Private m_hACam As Integer = 0
        Public m_Error As Integer = 1

        Public Function IsInit() As Boolean
            If 0 = m_hACam Then
                Return False
            Else
                Return True
            End If
        End Function


        Public Function GetDllVersion() As Integer
            Return CType(ArtCam.GetDllVersion(), Short)
        End Function

        Public Function GetDllType() As Integer
            Return ArtCam.GetDllVersion() / &H10000
        End Function

        Public Function GetLastError() As Integer
            Return ArtCam.GetLastError(m_hACam)
        End Function

        Public Function Initialize(ByVal hWnd As IntPtr) As Integer
            m_hACam = ArtCam.Initialize(hWnd)
            If 0 = m_hACam Then
                Return True
            Else
                Return False
            End If
        End Function

        Public Function Release() As Integer
            Return ArtCam.Release(m_hACam)
        End Function

        Public Function Preview() As Integer
            Return ArtCam.Preview(m_hACam)
        End Function

        Public Function Record(ByVal lpAviName As String, ByVal RecTime As Integer, ByVal fShow As Integer) As Integer
            Return ArtCam.Record(m_hACam, lpAviName, RecTime, fShow)
        End Function

        Public Function CallBackPreview(ByVal hWnd As IntPtr, ByVal lpImage As Byte(), ByVal Size As Integer, ByVal TopDown As Integer) As Integer
            Return ArtCam.CallBackPreviewA(m_hACam, hWnd, lpImage, Size, TopDown)
        End Function

        Public Function CallBackPreview(ByVal hWnd As IntPtr, ByVal lpImage As IntPtr, ByVal Size As Integer, ByVal TopDown As Integer) As Integer
            Return ArtCam.CallBackPreviewP(m_hACam, hWnd, lpImage, Size, TopDown)
        End Function

        Public Function SnapShot(ByVal lpImage As Byte(), ByVal Size As Integer, ByVal TopDown As Integer) As Integer
            Return ArtCam.SnapShotA(m_hACam, lpImage, Size, TopDown)
        End Function

        Public Function SnapShot(ByVal lpImage As IntPtr, ByVal Size As Integer, ByVal TopDown As Integer) As Integer
            Return ArtCam.SnapShotP(m_hACam, lpImage, Size, TopDown)
        End Function

        Public Function Close() As Integer
            Return ArtCam.Close(m_hACam)
        End Function

        ' 1250
        Public Function Capture() As Integer
            Return ArtCam.Capture(m_hACam)
        End Function

        ' 1260
        Public Function Trigger(ByVal hWnd As IntPtr, ByVal lpImage As Byte(), ByVal Size As Integer, ByVal TopDown As Integer) As Integer
            Return ArtCam.TriggerA(m_hACam, hWnd, lpImage, Size, TopDown)
        End Function

        Public Function Trigger(ByVal hWnd As IntPtr, ByVal lpImage As IntPtr, ByVal Size As Integer, ByVal TopDown As Integer) As Integer
            Return ArtCam.TriggerP(m_hACam, hWnd, lpImage, Size, TopDown)
        End Function

        Public Function SaveImage(ByVal lpSaveName As String, ByVal FileType As FILETYPE) As Integer
            Return ArtCam.SaveImage(m_hACam, lpSaveName, FileType)
        End Function

        Public Function SetPreviewWindow(ByVal hWnd As IntPtr, ByVal Left As Integer, ByVal Top As Integer, ByVal Right As Integer, ByVal Bottom As Integer) As Integer
            Return ArtCam.SetPreviewWindow(m_hACam, hWnd, Left, Top, Right, Bottom)
        End Function

        Public Function SetCaptureWindow(ByVal Width As Integer, ByVal Height As Integer, ByVal Frame As Integer) As Integer
            Return ArtCam.SetCaptureWindow(m_hACam, Width, Height, Frame)
        End Function

        Public Function SetCaptureWindowEx(ByVal HTotal As Integer, ByVal HStart As Integer, ByVal HEffective As Integer, ByVal VTotal As Integer, ByVal VStart As Integer, ByVal VEffective As Integer) As Integer
            Return ArtCam.SetCaptureWindowEx(m_hACam, HTotal, HStart, HEffective, VTotal, VStart, VEffective)
        End Function

        Public Function GetCaptureWindowEx(ByRef HTotal As Integer, ByRef HStart As Integer, ByRef HEffective As Integer, ByRef VTotal As Integer, ByRef VStart As Integer, ByRef VEffective As Integer) As Integer
            Return ArtCam.GetCaptureWindowEx(m_hACam, HTotal, HStart, HEffective, VTotal, VStart, VEffective)
        End Function

        Public Function SetColorMode(ByVal ColorMode As Integer) As Integer
            Return ArtCam.SetColorMode(m_hACam, ColorMode)
        End Function

        Public Function GetColorMode() As Integer
            Return ArtCam.GetColorMode(m_hACam)
        End Function

        Public Function SetCrossbar(ByVal Output As Integer, ByVal Input As Integer) As Integer
            Return ArtCam.SetCrossbar(m_hACam, Output, Input)
        End Function

        Public Function SetDeviceNumber(ByVal Number As Integer) As Integer
            Return ArtCam.SetDeviceNumber(m_hACam, Number)
        End Function

        Public Function GetDeviceName(ByVal index As Integer, ByVal szDeviceName As System.Text.StringBuilder, ByVal Size As Integer) As Integer
            Return ArtCam.GetDeviceName(m_hACam, index, szDeviceName, Size)
        End Function

        Public Function StartPreview() As Integer
            Return ArtCam.StartPreview(m_hACam)
        End Function

        Public Function StopPreview() As Integer
            Return ArtCam.StopPreview(m_hACam)
        End Function

        Public Function GetImage(ByVal lpImage As Byte(), ByVal Size As Integer, ByVal TopDown As Integer) As Integer
            Return ArtCam.GetImageA(m_hACam, lpImage, Size, TopDown)
        End Function

        Public Function GetImage(ByVal lpImage As IntPtr, ByVal Size As Integer, ByVal TopDown As Integer) As Integer
            Return ArtCam.GetImageP(m_hACam, lpImage, Size, TopDown)
        End Function

        Public Function Width() As Integer
            Return ArtCam.Width(m_hACam)
        End Function

        Public Function Height() As Integer
            Return ArtCam.Height(m_hACam)
        End Function

        Public Function Fps() As Integer
            Return ArtCam.Fps(m_hACam)
        End Function

        Public Function SetCameraDlg(ByVal hWnd As IntPtr) As Integer
            Return ArtCam.SetCameraDlg(m_hACam, hWnd)
        End Function

        Public Function SetImageDlg(ByVal hWnd As IntPtr) As Integer
            Return ArtCam.SetImageDlg(m_hACam, hWnd)
        End Function

        Public Function SetAnalogDlg(ByVal hWnd As IntPtr) As Integer
            Return ArtCam.SetAnalogDlg(m_hACam, hWnd)
        End Function

        ' 1230
        Public Function SetIOPort(ByVal byteData As Integer, ByVal longData As Integer, ByVal Reserve As Integer) As Integer
            Return ArtCam.SetIOPort(m_hACam, byteData, longData, Reserve)
        End Function

        Public Function GetIOPort(ByRef byteData As Byte, ByRef longData As Integer, ByVal Reserve As Integer) As Integer
            Return ArtCam.GetIOPort(m_hACam, byteData, longData, Reserve)
        End Function

        Public Function SetFilterValue(ByVal FilterType As Integer, ByVal Value As Integer) As Integer
            Return ArtCam.SetFilterValue(m_hACam, FilterType, Value)
        End Function

        Public Function GetFilterValue(ByVal FilterType As Integer) As Integer
            Return ArtCam.GetFilterValue(m_hACam, FilterType, m_Error)
        End Function

        Public Function SetSubSample(ByVal SubSampleMode As Integer) As Integer
            Return ArtCam.SetSubSample(m_hACam, SubSampleMode)
        End Function

        Public Function GetSubSample() As Integer
            Return ArtCam.GetSubSample(m_hACam)
        End Function

        Public Function SetWaitTime(ByVal WaitTime As Integer) As Integer
            Return ArtCam.SetWaitTime(m_hACam, WaitTime)
        End Function

        Public Function GetWaitTime() As Integer
            Return ArtCam.GetWaitTime(m_hACam)
        End Function

        ' 1240
        Public Function SetMirrorV(ByVal Flg As Integer) As Integer
            Return ArtCam.SetMirrorV(m_hACam, Flg)
        End Function

        Public Function GetMirrorV() As Integer
            Return ArtCam.GetMirrorV(m_hACam)
        End Function

        Public Function SetMirrorH(ByVal Flg As Integer) As Integer
            Return ArtCam.SetMirrorH(m_hACam, Flg)
        End Function

        Public Function GetMirrorH() As Integer
            Return ArtCam.GetMirrorH(m_hACam)
        End Function

        Public Function SetBrightness(ByVal Value As Integer) As Integer
            Return ArtCam.SetBrightness(m_hACam, Value)
        End Function

        Public Function GetBrightness() As Integer
            Return ArtCam.GetBrightness(m_hACam, m_Error)
        End Function

        Public Function SetContrast(ByVal Value As Integer) As Integer
            Return ArtCam.SetContrast(m_hACam, Value)
        End Function

        Public Function GetContrast() As Integer
            Return ArtCam.GetContrast(m_hACam, m_Error)
        End Function

        Public Function SetHue(ByVal Value As Integer) As Integer
            Return ArtCam.SetHue(m_hACam, Value)
        End Function

        Public Function GetHue() As Integer
            Return ArtCam.GetHue(m_hACam, m_Error)
        End Function

        Public Function SetSaturation(ByVal Value As Integer) As Integer
            Return ArtCam.SetSaturation(m_hACam, Value)
        End Function

        Public Function GetSaturation() As Integer
            Return ArtCam.GetSaturation(m_hACam, m_Error)
        End Function

        Public Function SetSharpness(ByVal Value As Integer) As Integer
            Return ArtCam.SetSharpness(m_hACam, Value)
        End Function

        Public Function GetSharpness() As Integer
            Return ArtCam.GetSharpness(m_hACam, m_Error)
        End Function

        Public Function SetBayerGainRGB(ByVal Value As Integer) As Integer
            Return ArtCam.SetBayerGainRGB(m_hACam, Value)
        End Function

        Public Function GetBayerGainRGB() As Integer
            Return ArtCam.GetBayerGainRGB(m_hACam, m_Error)
        End Function

        Public Function SetBayerGainRed(ByVal Value As Integer) As Integer
            Return ArtCam.SetBayerGainRed(m_hACam, Value)
        End Function

        Public Function GetBayerGainRed() As Integer
            Return ArtCam.GetBayerGainRed(m_hACam, m_Error)
        End Function

        Public Function SetBayerGainGreen(ByVal Value As Integer) As Integer
            Return ArtCam.SetBayerGainGreen(m_hACam, Value)
        End Function

        Public Function GetBayerGainGreen() As Integer
            Return ArtCam.GetBayerGainGreen(m_hACam, m_Error)
        End Function

        Public Function SetBayerGainBlue(ByVal Value As Integer) As Integer
            Return ArtCam.SetBayerGainBlue(m_hACam, Value)
        End Function

        Public Function GetBayerGainBlue() As Integer
            Return ArtCam.GetBayerGainBlue(m_hACam, m_Error)
        End Function

        Public Function SetBayerGainAuto(ByVal Value As Integer) As Integer
            Return ArtCam.SetBayerGainAuto(m_hACam, Value)
        End Function

        Public Function GetBayerGainAuto() As Integer
            Return ArtCam.GetBayerGainAuto(m_hACam, m_Error)
        End Function

        Public Function SetGamma(ByVal Value As Integer) As Integer
            Return ArtCam.SetGamma(m_hACam, Value)
        End Function

        Public Function GetGamma() As Integer
            Return ArtCam.GetGamma(m_hACam, m_Error)
        End Function

        Public Function SetBayerMode(ByVal Value As Integer) As Integer
            Return ArtCam.SetBayerMode(m_hACam, Value)
        End Function

        Public Function GetBayerMode() As Integer
            Return ArtCam.GetBayerMode(m_hACam, m_Error)
        End Function

        Public Function SetGlobalGain(ByVal Value As Integer) As Integer
            Return ArtCam.SetGlobalGain(m_hACam, Value)
        End Function

        Public Function GetGlobalGain() As Integer
            Return ArtCam.GetGlobalGain(m_hACam, m_Error)
        End Function

        Public Function SetColorGainRed(ByVal Value As Integer) As Integer
            Return ArtCam.SetColorGainRed(m_hACam, Value)
        End Function

        Public Function GetColorGainRed() As Integer
            Return ArtCam.GetColorGainRed(m_hACam, m_Error)
        End Function

        Public Function SetColorGainGreen1(ByVal Value As Integer) As Integer
            Return ArtCam.SetColorGainGreen1(m_hACam, Value)
        End Function

        Public Function GetColorGainGreen1() As Integer
            Return ArtCam.GetColorGainGreen1(m_hACam, m_Error)
        End Function

        Public Function SetColorGainGreen2(ByVal Value As Integer) As Integer
            Return ArtCam.SetColorGainGreen2(m_hACam, Value)
        End Function

        Public Function GetColorGainGreen2() As Integer
            Return ArtCam.GetColorGainGreen2(m_hACam, m_Error)
        End Function

        Public Function SetColorGainBlue(ByVal Value As Integer) As Integer
            Return ArtCam.SetColorGainBlue(m_hACam, Value)
        End Function

        Public Function GetColorGainBlue() As Integer
            Return ArtCam.GetColorGainBlue(m_hACam, m_Error)
        End Function

        Public Function SetExposureTime(ByVal Value As Integer) As Integer
            Return ArtCam.SetExposureTime(m_hACam, Value)
        End Function

        Public Function GetExposureTime() As Integer
            Return ArtCam.GetExposureTime(m_hACam, m_Error)
        End Function

        ' 1260
        Public Function SetHalfClock(ByVal Value As Integer) As Integer
            Return ArtCam.SetHalfClock(m_hACam, Value)
        End Function

        Public Function GetHalfClock() As Integer
            Return ArtCam.GetHalfClock(m_hACam, m_Error)
        End Function

        Public Function SetAutoIris(ByVal Value As Integer) As Integer
            Return ArtCam.SetAutoIris(m_hACam, Value)
        End Function

        Public Function GetAutoIris() As Integer
            Return ArtCam.GetAutoIris(m_hACam, m_Error)
        End Function

        ' 1275
        Public Function SetSamplingRate(ByVal Value As Integer) As Integer
            Return ArtCam.SetSamplingRate(m_hACam, Value)
        End Function

        Public Function GetSamplingRate() As Integer
            Return ArtCam.GetSamplingRate(m_hACam, m_Error)
        End Function

        Public Function GetVideoFormat() As Integer
            Return ArtCam.GetVideoFormat(m_hACam, m_Error)
        End Function

        ' 1276
        Public Function WriteSromID(ByVal Address As Integer, ByVal Value As Integer) As Integer
            Return ArtCam.WriteSromID(m_hACam, Address, Value)
        End Function

        Public Function ReadSromID(ByVal Address As Integer) As Integer
            Return ArtCam.ReadSromID(m_hACam, Address, m_Error)
        End Function

        ' 1280
        Public Function GetStatus(ByRef pError As Integer) As Integer
            Return ArtCam.GetStatus(m_hACam, m_Error)
        End Function

        Public Function WriteRegister(ByVal Address As Byte, ByVal Value As Integer) As Integer
            Return ArtCam.WriteRegister(m_hACam, Address, Value)
        End Function

        Public Function ReadRegister(ByVal Address As Byte, ByRef pError As Integer) As Integer
            Return ArtCam.ReadRegister(m_hACam, Address, m_Error)
        End Function

        Public Function SetGrayMode(ByVal Value As Integer) As Integer
            Return ArtCam.SetGrayMode(m_hACam, Value)
        End Function

        Public Function GetGrayMode(ByRef pError As Integer) As Integer
            Return ArtCam.GetGrayMode(m_hACam, m_Error)
        End Function

        Public Function SetGrayGainR(ByVal Value As Integer) As Integer
            Return ArtCam.SetGrayGainR(m_hACam, Value)
        End Function

        Public Function GetGrayGainR(ByRef pError As Integer) As Integer
            Return ArtCam.GetGrayGainR(m_hACam, m_Error)
        End Function

        Public Function SetGrayGainG1(ByVal Value As Integer) As Integer
            Return ArtCam.SetGrayGainG1(m_hACam, Value)
        End Function

        Public Function GetGrayGainG1(ByRef pError As Integer) As Integer
            Return ArtCam.GetGrayGainG1(m_hACam, m_Error)
        End Function

        Public Function SetGrayGainG2(ByVal Value As Integer) As Integer
            Return ArtCam.SetGrayGainG2(m_hACam, Value)
        End Function

        Public Function GetGrayGainG2(ByRef pError As Integer) As Integer
            Return ArtCam.GetGrayGainG2(m_hACam, m_Error)
        End Function

        Public Function SetGrayGainB(ByVal Value As Integer) As Integer
            Return ArtCam.SetGrayGainB(m_hACam, Value)
        End Function

        Public Function GetGrayGainB(ByRef pError As Integer) As Integer
            Return ArtCam.GetGrayGainB(m_hACam, m_Error)
        End Function

        Public Function SetGrayOffsetR(ByVal Value As Integer) As Integer
            Return ArtCam.SetGrayOffsetR(m_hACam, Value)
        End Function

        Public Function GetGrayOffsetR(ByRef pError As Integer) As Integer
            Return ArtCam.GetGrayOffsetR(m_hACam, m_Error)
        End Function

        Public Function SetGrayOffsetG1(ByVal Value As Integer) As Integer
            Return ArtCam.SetGrayOffsetG1(m_hACam, Value)
        End Function

        Public Function GetGrayOffsetG1(ByRef pError As Integer) As Integer
            Return ArtCam.GetGrayOffsetG1(m_hACam, m_Error)
        End Function

        Public Function SetGrayOffsetG2(ByVal Value As Integer) As Integer
            Return ArtCam.SetGrayOffsetG2(m_hACam, Value)
        End Function

        Public Function GetGrayOffsetG2(ByRef pError As Integer) As Integer
            Return ArtCam.GetGrayOffsetG2(m_hACam, m_Error)
        End Function

        Public Function SetGrayOffsetB(ByVal Value As Integer) As Integer
            Return ArtCam.SetGrayOffsetB(m_hACam, Value)
        End Function

        Public Function GetGrayOffsetB(ByRef pError As Integer) As Integer
            Return ArtCam.GetGrayOffsetB(m_hACam, m_Error)
        End Function

        Public Function SetCameraType(ByVal Flg As Integer) As Integer
            Return ArtCam.SetCameraType(m_hACam, Flg)
        End Function

        Public Function GetCameraType(ByRef pError As Integer) As Integer
            Return ArtCam.GetCameraType(m_hACam, m_Error)
        End Function

        Public Function Fpga_WriteRegister(ByVal Address As Byte, ByVal Value As Integer) As Integer
            Return ArtCam.Fpga_WriteRegister(m_hACam, Address, Value)
        End Function

        Public Function Fpga_ReadRegister(ByVal Address As Byte, ByRef pError As Integer) As Integer
            Return ArtCam.Fpga_ReadRegister(m_hACam, Address, m_Error)
        End Function

        Public Function Monitor_SetPreviewMode(ByVal Preview As Boolean) As Integer
            Return ArtCam.Monitor_SetPreviewMode(m_hACam, Preview)
        End Function

        Public Function Monitor_GetPreviewMode(ByRef pError As Integer) As Integer
            Return ArtCam.Monitor_GetPreviewMode(m_hACam, m_Error)
        End Function

        Public Function Monitor_SetPreviewSize(ByVal Width As Integer, ByVal Height As Integer) As Integer
            Return ArtCam.Monitor_SetPreviewSize(m_hACam, Width, Height)
        End Function

        Public Function Monitor_GetPreviewSize(ByRef Width As Integer, ByRef Height As Integer) As Integer
            Return ArtCam.Monitor_GetPreviewSize(m_hACam, Width, Height)
        End Function

        Public Function Monitor_SetColorMode(ByVal ColorMode As Boolean) As Integer
            Return ArtCam.Monitor_SetColorMode(m_hACam, ColorMode)
        End Function

        Public Function Monitor_GetColorMode(ByRef pError As Integer) As Integer
            Return ArtCam.Monitor_GetColorMode(m_hACam, m_Error)
        End Function

        Public Function Monitor_SetCameraClock(ByVal Value As Integer) As Integer
            Return ArtCam.Monitor_SetCameraClock(m_hACam, Value)
        End Function

        Public Function Monitor_GetCameraClock(ByRef pError As Integer) As Integer
            Return ArtCam.Monitor_GetCameraClock(m_hACam, m_Error)
        End Function

        Public Function Monitor_SetBayerGainAuto(ByVal Value As Integer) As Integer
            Return ArtCam.Monitor_SetBayerGainAuto(m_hACam, Value)
        End Function

        Public Function Monitor_GetBayerGainAuto(ByRef pError As Integer) As Integer
            Return ArtCam.Monitor_GetBayerGainAuto(m_hACam, m_Error)
        End Function

        Public Function Monitor_SetBayerGainLock(ByVal Value As Integer) As Integer
            Return ArtCam.Monitor_SetBayerGainLock(m_hACam, Value)
        End Function

        Public Function Monitor_GetBayerGainLock(ByRef pError As Integer) As Integer
            Return ArtCam.Monitor_GetBayerGainLock(m_hACam, m_Error)
        End Function

        Public Function Monitor_SetBayerGainRed(ByVal Value As Integer) As Integer
            Return ArtCam.Monitor_SetBayerGainRed(m_hACam, Value)
        End Function

        Public Function Monitor_GetBayerGainRed(ByRef pError As Integer) As Integer
            Return ArtCam.Monitor_GetBayerGainRed(m_hACam, m_Error)
        End Function

        Public Function Monitor_SetBayerGainGreen(ByVal Value As Integer) As Integer
            Return ArtCam.Monitor_SetBayerGainGreen(m_hACam, Value)
        End Function

        Public Function Monitor_GetBayerGainGreen(ByRef pError As Integer) As Integer
            Return ArtCam.Monitor_GetBayerGainGreen(m_hACam, m_Error)
        End Function

        Public Function Monitor_SetBayerGainBlue(ByVal Value As Integer) As Integer
            Return ArtCam.Monitor_SetBayerGainBlue(m_hACam, Value)
        End Function

        Public Function Monitor_GetBayerGainBlue(ByRef pError As Integer) As Integer
            Return ArtCam.Monitor_GetBayerGainBlue(m_hACam, m_Error)
        End Function


        Public Function SetSyncV(ByVal Flg As Integer) As Integer
            Return ArtCam.SetSyncV(m_hACam, Flg)
        End Function

        Public Function GetSyncV(ByRef pError As Integer) As Integer
            Return ArtCam.GetSyncV(m_hACam, m_Error)
        End Function

        Public Function SetSyncH(ByVal Flg As Integer) As Integer
            Return ArtCam.SetSyncH(m_hACam, Flg)
        End Function

        Public Function GetSyncH(ByRef pError As Integer) As Integer
            Return ArtCam.GetSyncH(m_hACam, m_Error)
        End Function

        Public Function WriteRegisterEx(ByVal Address As Integer, ByVal Value As Integer) As Integer
            Return ArtCam.WriteRegisterEx(m_hACam, Address, Value)
        End Function

        Public Function ReadRegisterEx(ByVal Address As Integer, ByRef pError As Integer) As Integer
            Return ArtCam.ReadRegisterEx(m_hACam, Address, m_Error)
        End Function

        Public Function Monitor_SaveCurrentSettings() As Integer
            Return ArtCam.Monitor_SaveCurrentSettings(m_hACam)
        End Function

        Public Function Monitor_InitRegisterSettings(ByVal Flg As Integer) As Integer
            Return ArtCam.Monitor_InitRegisterSettings(m_hACam, Flg)
        End Function

        Public Function Monitor_LoadFirmware(ByVal szFileName As System.Text.StringBuilder)
            Return ArtCam.Monitor_LoadFirmware(m_hACam, szFileName)
        End Function

        Public Function Monitor_SetCrossCursorMode(ByVal CursorNum As Integer, ByVal Value As Integer) As Integer
            Return ArtCam.Monitor_SetCrossCursorMode(m_hACam, CursorNum, Value)
        End Function
        Public Function Monitor_GetCrossCursorMode(ByVal CursorNum As Integer, ByRef pError As Integer) As Integer
            Return ArtCam.Monitor_GetCrossCursorMode(m_hACam, CursorNum, m_Error)
        End Function
        Public Function Monitor_SetCrossCursorColorR(ByVal CursorNum As Integer, ByVal Value As Integer) As Integer
            Return ArtCam.Monitor_SetCrossCursorColorR(m_hACam, CursorNum, Value)
        End Function
        Public Function Monitor_GetCrossCursorColorR(ByVal CursorNum As Integer, ByRef pError As Integer) As Integer
            Return ArtCam.Monitor_GetCrossCursorColorR(m_hACam, CursorNum, m_Error)
        End Function

        Public Function Monitor_SetCrossCursorColorG(ByVal CursorNum As Integer, ByVal Value As Integer) As Integer
            Return ArtCam.Monitor_SetCrossCursorColorG(m_hACam, CursorNum, Value)
        End Function

        Public Function Monitor_GetCrossCursorColorG(ByVal CursorNum As Integer, ByRef pError As Integer) As Integer
            Return ArtCam.Monitor_GetCrossCursorColorG(m_hACam, CursorNum, m_Error)
        End Function

        Public Function Monitor_SetCrossCursorColorB(ByVal CursorNum As Integer, ByVal Value As Integer) As Integer
            Return ArtCam.Monitor_SetCrossCursorColorB(m_hACam, CursorNum, Value)
        End Function

        Public Function Monitor_GetCrossCursorColorB(ByVal CursorNum As Integer, ByRef pError As Integer) As Integer
            Return ArtCam.Monitor_GetCrossCursorColorB(m_hACam, CursorNum, m_Error)
        End Function

        Public Function Monitor_SetCrossCursorColorRGB(ByVal CursorNum As Integer, ByVal Value As Integer) As Integer
            Return ArtCam.Monitor_SetCrossCursorColorRGB(m_hACam, CursorNum, Value)
        End Function

        Public Function Monitor_GetCrossCursorColorRGB(ByVal CursorNum As Integer, ByRef pError As Integer) As Integer
            Return ArtCam.Monitor_GetCrossCursorColorRGB(m_hACam, CursorNum, m_Error)
        End Function

        Public Function Monitor_SetCrossCursorPos(ByVal CursorNum As Integer, ByVal ValueX As Integer, ByVal ValueY As Integer) As Integer
            Return ArtCam.Monitor_SetCrossCursorPos(m_hACam, CursorNum, ValueX, ValueY)
        End Function

        Public Function Monitor_GetCrossCursorPos(ByVal CursorNum As Integer, ByRef ValueX As Integer, ByRef ValueY As Integer) As Integer
            Return ArtCam.Monitor_GetCrossCursorPos(m_hACam, CursorNum, ValueX, ValueY)
        End Function

        Public Function Monitor_SetCrossCursorSize(ByVal CursorNum As Integer, ByVal ValueX As Integer, ByVal ValueY As Integer) As Integer
            Return ArtCam.Monitor_SetCrossCursorSize(m_hACam, CursorNum, ValueX, ValueY)
        End Function

        Public Function Monitor_GetCrossCursorSize(ByVal CursorNum As Integer, ByRef ValueX As Integer, ByRef ValueY As Integer) As Integer
            Return ArtCam.Monitor_GetCrossCursorSize(m_hACam, CursorNum, ValueX, ValueY)
        End Function

        Public Function Monitor_SetAutoIrisMode(ByVal Value As Integer) As Integer
            Return ArtCam.Monitor_SetAutoIrisMode(m_hACam, Value)
        End Function

        Public Function Monitor_GetAutoIrisMode(ByRef pError As Integer) As Integer
            Return ArtCam.Monitor_GetAutoIrisMode(m_hACam, m_Error)
        End Function

        Public Function Monitor_SetAutoIrisRange(ByVal Min As Integer, ByVal Max As Integer) As Integer
            Return ArtCam.Monitor_SetAutoIrisRange(m_hACam, Min, Max)
        End Function

        Public Function Monitor_GetAutoIrisRange(ByRef Min As Integer, ByRef Max As Integer) As Integer
            Return ArtCam.Monitor_GetAutoIrisRange(m_hACam, Min, Max)
        End Function

        Public Function GetRealExposureTime() As Integer
            Return ArtCam.GetRealExposureTime(m_hACam)
        End Function


    End Class

End Namespace
