//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;


TCHAR DllName[][256] = {
	"ArtCamSdk.dll",
	"",
	"ArtCamSdk_USTC.dll",
	"ArtCnvSdk.dll",
	"",
	"ArtCamSdk_130MI.dll",
	"ArtCamSdk_200MI.dll",
	"ArtCamSdk_300MI.dll",
	"ArtCamSdk_150P.dll",
	"ArtCamSdk_320P.dll",
	"ArtCamSdk_200SH.dll",
	"ArtCamSdk_098.dll",
	"ArtCamSdk_036MI.dll",
	"ArtCamSdk_500P.dll",
	"ArtCamSdk_150P2.dll"
};


//---------------------------------------------------------------------------
LRESULT CALLBACK MsgProc(int nCode, WPARAM wp, LPARAM lp)
{
	if(nCode < 0)
		return CallNextHookEx(Form1->m_Hook, nCode, wp, lp);

	if(HC_ACTION == nCode){
		PMsg Msg = (PMsg)lp;

		// `R[h@ŐV̉f荞܂ꂽۂɂrcj瑗܂
		if(WM_GRAPHPAINT == Msg->message){
			Form1->DrawImage();
		}

		// G[R[h
		if(WM_ERROR == Msg->message){
			switch(Msg->lParam){
			case ARTCAMSDK_NOERROR:         Form1->Caption = "Sample";	break;
			case ARTCAMSDK_NOT_INITIALIZE:  Form1->Caption = "Ă܂";	break;
			case ARTCAMSDK_DISABLEDDEVICE:  Form1->Caption = "ps\ȃfoCXɃANZX悤Ƃ܂";	break;
			case ARTCAMSDK_CREATETHREAD:    Form1->Caption = "摜荞ݗpXbh쐬Ɏs";	break;
			case ARTCAMSDK_CREATEWINDOW:    Form1->Caption = "EBhE쐬Ɏs";	break;
			case ARTCAMSDK_OUTOFMEMORY:     Form1->Caption = "C[W]ɏ\ȃmۂĂȂ@́@̊mۂɎs";	break;
			case ARTCAMSDK_CAMERASET:       Form1->Caption = "JifoCXj̐ݒŃG[";	break;
			case ARTCAMSDK_CAPTURE:         Form1->Caption = "f荞݂Ŏs";	break;
			case ARTCAMSDK_PARAM:           Form1->Caption = "ԈĂ܂";	break;
			case ARTCAMSDK_DIRECTSHOW:      Form1->Caption = "DirectShow G[";	break;
			case ARTCAMSDK_UNSUPPORTED:     Form1->Caption = "̋@\̓T|[gĂ܂";	break;
			case ARTCAMSDK_UNKNOWN:         Form1->Caption = "s̃G[";	break;
			case ARTCAMSDK_CAPTURELOST:     Form1->Caption = "foCX܂";	break;
			default:                        Form1->Caption = "s̃G[";	break;
			}
		}
	}

	return CallNextHookEx(Form1->m_Hook, nCode, wp, lp);
}


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
		: TForm(Owner)
		, m_DllType(-1)
		, m_PreviewMode(1)
		, m_BmpDraw(NULL)
		, m_Hook(NULL)
{
	Timer1->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
	for(int i=0; i<15; i++){
		if(!m_CArtCamSdk.LoadLibrary(DllName[i])){
			(*PopupDll)[i]->Enabled = false;
		}
		m_CArtCamSdk.FreeLibrary();
	}

	m_Hook = SetWindowsHookEx(WH_GETMESSAGE, (HOOKPROC)MsgProc, 0, GetCurrentThreadId());
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveClick(TObject *Sender)
{
	m_CArtCamSdk.SaveImage("Temp.jpg", FILETYPE_JPEG_NOMAL);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ExitClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PreviewClick(TObject *Sender)
{
	// DLLI
	if(-1 == m_DllType){
		ShowMessage("ڑĂJDLLIĂ");
		return;
	}

	// ^C}[폜
	if(3 == m_PreviewMode){
		Timer1->Enabled = false;
	}

	// ňUfoCXJ
	m_CArtCamSdk.Close();

	// \EBhEݒ肷
	// Handle NULLݒ肷ƐVEBhE쐬ĕ\܂
	TRect rc = GetClientRect();
	m_CArtCamSdk.SetPreviewWindow(Handle, 0, 0, rc.right, rc.bottom);

	// f\
	// \͂rcjŐ䂵܂̂ŉfɊւ͊{IɎ擾ł܂B
	m_CArtCamSdk.Preview();

	// j[`FbN
	ShowPreview->Checked  = true;
	ShowCallBack->Checked = false;
	ShowCapture->Checked  = false;
	ShowTrigger->Checked  = false;

	Invalidate();
	m_PreviewMode = 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CallBackClick(TObject *Sender)
{
	// DLLI
	if(-1 == m_DllType){
		ShowMessage("ڑĂJDLLIĂ");
		return;
	}

	// ^C}[폜
	if(3 == m_PreviewMode){
		Timer1->Enabled = false;
	}

	// ňUfoCXJ
	m_CArtCamSdk.Close();

	// ŕ`悷ꍇ̓EBhETCYSĂOɂ܂
	// CallBackPreview gpꍇłEBhETCYݒ肷Ύ\͍s܂B
	m_CArtCamSdk.SetPreviewWindow(Handle, 0, 0, 0, 0);

	// 荞ݗp̈쐬
	CreateBitmap();

	// f荞
	m_CArtCamSdk.CallBackPreview(Handle, (LPBYTE)m_BmpDraw->ScanLine[m_BmpDraw->Height-1], ArtCamGetSize(), 0);

	// j[`FbN
	ShowPreview->Checked  = false;
	ShowCallBack->Checked = true;
	ShowCapture->Checked  = false;
	ShowTrigger->Checked  = false;

	Invalidate();
	m_PreviewMode = 1;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SnapShotClick(TObject *Sender)
{
	// DLLI
	if(-1 == m_DllType){
		ShowMessage("ڑĂJDLLIĂ");
		return;
	}

	// ^C}[폜
	if(3 == m_PreviewMode){
		Timer1->Enabled = false;
	}

	// ňUfoCXJ
	m_CArtCamSdk.Close();

	// 荞ݗp̈쐬
	CreateBitmap();

	// f荞
	m_CArtCamSdk.SnapShot((LPBYTE)m_BmpDraw->ScanLine[m_BmpDraw->Height-1], ArtCamGetSize(), 0);

	// 摜`
	DrawImage();

	// j[`FbN
	ShowPreview->Checked  = false;
	ShowCallBack->Checked = false;
	ShowCapture->Checked  = false;
	ShowTrigger->Checked  = false;

//	Invalidate();
	m_PreviewMode = -1;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CaptureClick(TObject *Sender)
{
	// DLLI
	if(-1 == m_DllType){
		ShowMessage("ڑĂJDLLIĂ");
		return;
	}

	// ňUfoCXJ
	m_CArtCamSdk.Close();

	// \EBhEݒ肷
	// Handle NULLݒ肷ƐVEBhE쐬ĕ\܂
	TRect rc = GetClientRect();
	m_CArtCamSdk.SetPreviewWindow(Handle, 0, 0, rc.right, rc.bottom);

	// 荞ݗp̈쐬
	CreateBitmap();

	// f\
	m_CArtCamSdk.Capture();

	// j[`FbN
	ShowPreview->Checked  = false;
	ShowCallBack->Checked = false;
	ShowCapture->Checked  = true;
	ShowTrigger->Checked  = false;

	Invalidate();
	m_PreviewMode = 3;

	Timer1->Enabled = true;
	Timer1->Interval = 200;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TriggerClick(TObject *Sender)
{
	// DLLI
	if(-1 == m_DllType){
		ShowMessage("ڑĂJDLLIĂ");
		return;
	}

	// ^C}[폜
	if(3 == m_PreviewMode){
		Timer1->Enabled = false;
	}

	// ňUfoCXJ
	m_CArtCamSdk.Close();

	// ŕ`悷ꍇ̓EBhETCYSĂOɂ܂
	// CallBackPreview gpꍇłEBhETCYݒ肷Ύ\͍s܂B
	m_CArtCamSdk.SetPreviewWindow(Handle, 0, 0, 0, 0);

	// 荞ݗp̈쐬
	CreateBitmap();

	// f荞
	m_CArtCamSdk.Trigger(Handle, (LPBYTE)m_BmpDraw->ScanLine[m_BmpDraw->Height-1], ArtCamGetSize(), 0);

	// j[`FbN
	ShowPreview->Checked  = false;
	ShowCallBack->Checked = false;
	ShowCapture->Checked  = false;
	ShowTrigger->Checked  = true;

	Invalidate();
	m_PreviewMode = 4;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SetCameraClick(TObject *Sender)
{
	m_CArtCamSdk.SetCameraDlg(Handle);

	Invalidate();
	switch(m_PreviewMode){
	case 0:	PreviewClick(Sender); break;
	case 1:	CallBackClick(Sender); break;
	case 3:	CaptureClick(Sender); break;
	case 4:	TriggerClick(Sender); break;
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SetFilterClick(TObject *Sender)
{
	m_CArtCamSdk.SetImageDlg(Handle);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SetAnalogClick(TObject *Sender)
{
	m_CArtCamSdk.SetAnalogDlg(Handle);
}
//---------------------------------------------------------------------------
void TForm1::OnDeviceChange(TObject *Sender, LONG Number)
{
	// DLLI
	if(-1 == m_DllType){
		ShowMessage("ڑĂJDLLIĂ");
		return;
	}


	// foCXύXOɎgp̃foCXJ
	m_CArtCamSdk.Close();

	// ŃfoCX̔ԍύXĂJ\ƃfoCXύX
	// F̊֐P̂ł̓foCX͕ύX܂B
	// @@̊֐ĂяoɃfoCX鎖ŃfoCXύX܂
	m_CArtCamSdk.SetDeviceNumber(Number);

	for(int i=0; i<10; i++){
		(*PopupDevice)[i]->Checked = false;
	}
	(*PopupDevice)[Number]->Checked = true;


	switch(m_PreviewMode){
	case 0:	PreviewClick(Sender); break;
	case 1:	CallBackClick(Sender); break;
	case 3:	CaptureClick(Sender); break;
	case 4:	TriggerClick(Sender); break;
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Device0Click(TObject *Sender) { OnDeviceChange(Sender,  0); }
void __fastcall TForm1::Device1Click(TObject *Sender) { OnDeviceChange(Sender,  1); }
void __fastcall TForm1::Device2Click(TObject *Sender) { OnDeviceChange(Sender,  2); }
void __fastcall TForm1::Device3Click(TObject *Sender) { OnDeviceChange(Sender,  3); }
void __fastcall TForm1::Device4Click(TObject *Sender) { OnDeviceChange(Sender,  4); }
void __fastcall TForm1::Device5Click(TObject *Sender) { OnDeviceChange(Sender,  5); }
void __fastcall TForm1::Device6Click(TObject *Sender) { OnDeviceChange(Sender,  6); }
void __fastcall TForm1::Device7Click(TObject *Sender) { OnDeviceChange(Sender,  7); }
void __fastcall TForm1::Device8Click(TObject *Sender) { OnDeviceChange(Sender,  8); }
void __fastcall TForm1::Device9Click(TObject *Sender) { OnDeviceChange(Sender,  9); }
//---------------------------------------------------------------------------
void TForm1::OnDllChange(TObject *Sender, LONG Number)
{
	// ckk؂ւۂ͈USĊJ܂B
	// ̃J̓\sۂ CArtCamSdk 𕡐`Kv܂B
	// `Ăꍇ̓J؂ւ̍ۂɊJKv͂ȂȂ܂B
	m_CArtCamSdk.Release();
	m_CArtCamSdk.FreeLibrary();

	m_DllType = Number;

	if(!m_CArtCamSdk.LoadLibrary(DllName[m_DllType])){
		TCHAR Error[256]="";
		wsprintf(Error, "%s܂\nNDLLړ\܂", DllName[m_DllType]);
		ShowMessage(Error);
		return;
	}

	// IDLL`FbN
	for(int i=0; i<15; i++){
		(*PopupDll)[i]->Checked = false;
	}
	(*PopupDll)[m_DllType]->Checked = true;


	// Initialize ͍ŏɌĂт܂
	// ŃEBhEnhݒ肷WM_ERROR擾鎖o
	if(!m_CArtCamSdk.Initialize(Handle)){
		ShowMessage("rcj̏Ɏs܂");
		return;
	}

	TCHAR szName[10][256];
	LONG DeviceCount = m_CArtCamSdk.EnumDevice(szName);
	int i=0;
	for(; i<DeviceCount; i++){
		(*PopupDevice)[i]->Caption = szName[i];
		(*PopupDevice)[i]->Enabled = true;
	}
	for(; i<10; i++){
		(*PopupDevice)[i]->Caption = IntToStr(i);
		(*PopupDevice)[i]->Enabled = false;
		(*PopupDevice)[i]->Checked = false;
	}

	(*PopupDevice)[0]->Checked = true;


//	m_CArtCamSdk.SetHalfClock(0);
//	m_CArtCamSdk.SetAutoIris(1);

	switch(m_PreviewMode){
	case 0:	PreviewClick(Sender); break;
	case 1:	CallBackClick(Sender); break;
	case 3:	CaptureClick(Sender); break;
	case 4:	TriggerClick(Sender); break;
	}
}
//---------------------------------------------------------------------------
void TForm1::DrawImage(void)
{
	// 摜`
	Canvas->Draw(0, 0, m_BmpDraw);
}
//---------------------------------------------------------------------------
void TForm1::CreateBitmap(void)
{
	// fp̗̈J
	if(m_BmpDraw){
		delete m_BmpDraw;
		m_BmpDraw = NULL;
	}

	// \p̈쐬
	m_BmpDraw = new Graphics::TBitmap;
	m_BmpDraw->Width = ArtCamGetWidth();
	m_BmpDraw->Height = ArtCamGetHeight();
	m_BmpDraw->Canvas->Pen->Color = clRed;

	// WrbgmN摜̍ۂ̓pbg𐶐܂
	if(1 == ArtCamGetBpp()){
		m_BmpDraw->PixelFormat = pf8bit;
		TMaxLogPalette pal;
		for(int i=0; i<256; i++){
			pal.palPalEntry[i].peRed   = i;
			pal.palPalEntry[i].peGreen = i;
			pal.palPalEntry[i].peBlue  = i;
			pal.palPalEntry[i].peFlags = 0;
		}
		pal.palNumEntries = 256;
		pal.palVersion = 0x0300;
		m_BmpDraw->Palette = CreatePalette(PLogPalette(&pal));
	}
	// QSrbgJ[
	else if(3 == ArtCamGetBpp()){
		m_BmpDraw->PixelFormat = pf24bit;
	}

	// ȊO̐Fgpꍇ
	// Sample_BCB6_Graphic&Allbpp
	// QƂɂĂ

}
//---------------------------------------------------------------------------
void __fastcall TForm1::DSCameraClick   (TObject *Sender) { OnDllChange(Sender,  0); }
void __fastcall TForm1::ARTUSTClick     (TObject *Sender) { OnDllChange(Sender,  2); }
void __fastcall TForm1::ARTCNVClick     (TObject *Sender) { OnDllChange(Sender,  3); }
void __fastcall TForm1::ARTCAM130MIClick(TObject *Sender) { OnDllChange(Sender,  5); }
void __fastcall TForm1::ARTCAM200MIClick(TObject *Sender) { OnDllChange(Sender,  6); }
void __fastcall TForm1::ARTCAM300MIClick(TObject *Sender) { OnDllChange(Sender,  7); }
void __fastcall TForm1::ARTCAM150PClick (TObject *Sender) { OnDllChange(Sender,  8); }
void __fastcall TForm1::ARTCAM320PClick (TObject *Sender) { OnDllChange(Sender,  9); }
void __fastcall TForm1::ARTCAM200SHClick(TObject *Sender) { OnDllChange(Sender, 10); }
void __fastcall TForm1::ARTCAM098Click  (TObject *Sender) { OnDllChange(Sender, 11); }
void __fastcall TForm1::ARTCAM036MIClick(TObject *Sender) { OnDllChange(Sender, 12); }
void __fastcall TForm1::ARTCAM500PClick (TObject *Sender) { OnDllChange(Sender, 13); }
void __fastcall TForm1::ARTCAM150P2Click(TObject *Sender) { OnDllChange(Sender, 14); }

//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
	m_CArtCamSdk.SnapShot((LPBYTE)m_BmpDraw->ScanLine[m_BmpDraw->Height-1], ArtCamGetSize(), 0);

	// 摜`
	DrawImage();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
	UnhookWindowsHookEx(m_Hook);
	m_Hook = NULL;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormResize(TObject *Sender)
{
	// vr[[h̍ۂ͂rcjō쐬ꂽqEBhẼTCYςƕ\TCYς܂
	if(0 == m_PreviewMode){
		HWND hChild = GetWindow(Handle, GW_CHILD);

		RECT rc = GetClientRect();

		// AXyNgςȂꍇ͂̃̕RgOĂ
/*
		// vZ͏PʂɂȂ̂ňU_^ɂĂ܂
		double winW = rc.right;
		double winH = rc.bottom;
		double capW = ArtCamGetWidth();
		double capH = ArtCamGetHeight();

		if( (winW * capH) > (winH * capW) ){
			winW = winH * capW / capH;
			rc.right = LONG(winW);
		}
		else if( (winW * capH) < (winH * capW) ){
			winH = winW * capH / capW;
			rc.bottom = LONG(winH);
		}
*/
		SetWindowPos(hChild, HWND_TOP, 0, 0, rc.right, rc.bottom, SWP_NOMOVE | SWP_NOZORDER | SWP_SHOWWINDOW);
	}
}
//---------------------------------------------------------------------------

