#if !defined(AFX_SETSIZEDLG_H__912044CA_A0FB_4303_912F_BB1D0E1EA35A__INCLUDED_)
#define AFX_SETSIZEDLG_H__912044CA_A0FB_4303_912F_BB1D0E1EA35A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SetSizeDlg.h : Header File
//

#include "CArtCamSdk.hpp"

/////////////////////////////////////////////////////////////////////////////
// CSetSizeDlg Dialog

class CSetSizeDlg : public CDialog
{
	BOOL	m_Init;
	BOOL	m_SubCode;

public:
	CArtCamSdk*		m_pCArtCamSdk;
	LONG			m_DllType;


	void	InitCameraSize();
	void	InitColorMode();
	void	InitSubSample();
	void	InitCNV();
	void	InitSubCode();

// Construction
public:
	CSetSizeDlg(CWnd* pParent = NULL);   // Standard constructor

// Dialog data
	//{{AFX_DATA(CSetSizeDlg)
	enum { IDD = IDD_SETSIZE };
	long	m_TV;
	long	m_EV;
	long	m_EVS;
	long	m_TH;
	long	m_EH;
	long	m_EHS;
	long	m_FPS;
	int		m_SubSample;
	int		m_ColorMode;
	int		m_SamplingRate;
	int		m_Channel;
	BYTE	m_Code1;
	BYTE	m_Code2;
	BYTE	m_Code3;
	BYTE	m_Code4;
	BYTE	m_Code5;
	BYTE	m_Code6;
	BYTE	m_Code7;
	BYTE	m_Code8;
	//}}AFX_DATA


// Override
	// ClassWizard creates override of hypothetical function
	//{{AFX_VIRTUAL(CSetSizeDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Created message map function
	//{{AFX_MSG(CSetSizeDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ inserts additional declaration before the front line.

#endif // !defined(AFX_SETSIZEDLG_H__912044CA_A0FB_4303_912F_BB1D0E1EA35A__INCLUDED_)
