//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include "CArtCamSdk.hpp"
#include <ExtCtrls.hpp>
#include <AppEvnts.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TMainMenu *MainMenu1;
	TMenuItem *PopupFile;
	TMenuItem *PopupShow;
	TMenuItem *PopupSet;
	TMenuItem *PopupDevice;
	TMenuItem *PopupDll;
	TMenuItem *FileSave;
	TMenuItem *FileExit;
	TMenuItem *ShowPreview;
	TMenuItem *ShowCallBack;
	TMenuItem *ShowSnapShot;
	TMenuItem *ShowCapture;
	TMenuItem *ShowTrigger;
	TMenuItem *SetCamera;
	TMenuItem *SetFilter;
	TMenuItem *SetAnalog;
	TMenuItem *Device0;
	TMenuItem *Device1;
	TMenuItem *Device2;
	TMenuItem *Device3;
	TMenuItem *Device4;
	TMenuItem *Device5;
	TMenuItem *Device6;
	TMenuItem *Device7;
	TMenuItem *DIRECTSHOW;
	TMenuItem *ARTUST;
	TMenuItem *ARTCNV;
	TMenuItem *ARTCAM130MI;
	TMenuItem *ARTCAM200MI;
	TMenuItem *ARTCAM300MI;
	TMenuItem *ARTCAM150P;
	TMenuItem *ARTCAM320P;
	TMenuItem *ARTCAM200SH;
	TMenuItem *ARTCAM098;
	TMenuItem *ARTCAM036MI;
	TMenuItem *ARTCAM500P;
	TMenuItem *ARTCAM150P2;
	TTimer *Timer1;
	TMenuItem *N1;
	TMenuItem *N2;
	TMenuItem *FileRec;
	TMenuItem *N4;
	TMenuItem *ShowStop;
	TMenuItem *N5;
	TMenuItem *SetUserSize;
	TMenuItem *SetUserFilter;
	TSaveDialog *SaveDialog1;
	TTimer *RecTimer;

	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall SaveClick(TObject *Sender);
	void __fastcall ExitClick(TObject *Sender);
	void __fastcall PreviewClick(TObject *Sender);
	void __fastcall CallBackClick(TObject *Sender);
	void __fastcall SnapShotClick(TObject *Sender);
	void __fastcall CaptureClick(TObject *Sender);
	void __fastcall TriggerClick(TObject *Sender);
	void __fastcall SetCameraClick(TObject *Sender);
	void __fastcall SetFilterClick(TObject *Sender);
	void __fastcall SetAnalogClick(TObject *Sender);
	void __fastcall Device0Click(TObject *Sender);
	void __fastcall Device1Click(TObject *Sender);
	void __fastcall Device2Click(TObject *Sender);
	void __fastcall Device3Click(TObject *Sender);
	void __fastcall Device4Click(TObject *Sender);
	void __fastcall Device5Click(TObject *Sender);
	void __fastcall Device6Click(TObject *Sender);
	void __fastcall Device7Click(TObject *Sender);
	void __fastcall Device8Click(TObject *Sender);
	void __fastcall Device9Click(TObject *Sender);
	void __fastcall DSCameraClick(TObject *Sender);
	void __fastcall ARTUSTClick(TObject *Sender);
	void __fastcall ARTCNVClick(TObject *Sender);
	void __fastcall ARTCAM130MIClick(TObject *Sender);
	void __fastcall ARTCAM200MIClick(TObject *Sender);
	void __fastcall ARTCAM300MIClick(TObject *Sender);
	void __fastcall ARTCAM150PClick(TObject *Sender);
	void __fastcall ARTCAM320PClick(TObject *Sender);
	void __fastcall ARTCAM200SHClick(TObject *Sender);
	void __fastcall ARTCAM098Click(TObject *Sender);
	void __fastcall ARTCAM036MIClick(TObject *Sender);
	void __fastcall ARTCAM500PClick(TObject *Sender);
	void __fastcall ARTCAM150P2Click(TObject *Sender);
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall SetUserSizeClick(TObject *Sender);
	void __fastcall SetUserFilterClick(TObject *Sender);
	void __fastcall FileRecClick(TObject *Sender);
	void __fastcall PopupFileClick(TObject *Sender);
	void __fastcall PopupShowClick(TObject *Sender);
	void __fastcall PopupSetClick(TObject *Sender);

private:	// [U[錾
	LONG					m_DllType;
	LONG					m_PreviewMode;
	CArtCamSdk				m_CArtCamSdk;
	LPBYTE					m_BmpCapture;
	Graphics::TBitmap*		m_BmpDraw;

	LONG			m_SelectDevice;		// IĂfoCXԍ
	BOOL			m_StopFlg;			// ~
	AnsiString		m_RecName;

	void	OnDllChange(TObject *Sender, LONG Number);
	void	OnDeviceChange(TObject *Sender, LONG Number);
	void	CreateBitmap(void);
	void	ChangeScrollbar	(void);

public:		// [U[錾
	HHOOK	m_Hook;
	BOOL	m_SaveFlg;			// ۑ\
	void	DrawImage(void);
	void	ReDraw(void);

	__fastcall TForm1(TComponent* Owner);
};

const int SUB_SAMPLE[] = { 1, 2, 4, 8 };
#define ArtCamGetWidth()	(m_CArtCamSdk.Width()  / SUB_SAMPLE[m_CArtCamSdk.GetSubSample()])
#define ArtCamGetHeight()	(m_CArtCamSdk.Height() / SUB_SAMPLE[m_CArtCamSdk.GetSubSample()])
#define ArtCamGetColor()	WORD(((m_CArtCamSdk.GetColorMode() + 7) / 8) * 8)
#define ArtCamGetBpp()		(((m_CArtCamSdk.GetColorMode() + 7) / 8))
#define ArtCamGetPitch()	((ArtCamGetWidth() * ArtCamGetBpp() + 3) & ~3)
#define ArtCamGetSize()		(ArtCamGetPitch() * ArtCamGetHeight())



//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
 